HST = { };
HST["version"] = "1.0"

local completion_status = { };
completion_status["dungeons"] = 0;
completion_status["world_quests"] = 0;
completion_status["honorable_kills"] = 0;

local DUNGEONS_MAX = 100;
local WORLD_QUESTS_MAX = 200;
local HONORABLE_KILLS_MAX = 1000;

SlashCmdList["HST"] = function()
	HST:printStats()
end
SLASH_HST1 = "/hst"
SLASH_HST2 = "/HST"
SLASH_HST3 = "/hiddenskintracker"

local function getDungeonStats()
	-- Dungeon achievement is divided by dungeons. Total number completed is a sum of these.
	local dungeon_count = 0

	for i=1, 10 do
		local _, _, _, dungeon, _ = GetAchievementCriteriaInfo(11152, i);
		dungeon_count = dungeon_count + dungeon
	end
	return dungeon_count
end

local function colorTextByValue(value, max)
	-- Yolo
	local red = "|cffD50000"
	local orange = "|cffFF3D00"
	local yellow = "|cffFFEA00"
	local green = "|cff00C853"
	local ratio = value / max
	local return_string = ""

	if (ratio <= 0.33) then
		return_string = red .. value .. "|r"
	elseif (ratio > 0.33 and ratio <= 0.67) then
		return_string = orange .. value .. "|r"
	elseif (ratio > 0.67 and ratio < 1.00 ) then
		return_string = yellow .. value .. "|r"
	else
		return_string = green .. value .. "|r"
	end
	return return_string
end

function HST:updateStats()
	-- Do the stuff
	local dungeons_done = getDungeonStats();
	local _, _, _, world_quests_done, _ = GetAchievementCriteriaInfo(11153,1);
	local _, _, _, honorable_kills_done, _ = GetAchievementCriteriaInfo(11154,1);
	completion_status["dungeons"] = dungeons_done;
	completion_status["world_quests"] = world_quests_done;
	completion_status["honorable_kills"] = honorable_kills_done;
end

function HST:printStats()
	-- Make it pretty
	local dungeons_completed = colorTextByValue(completion_status["dungeons"], DUNGEONS_MAX)
	local wqs_completed = colorTextByValue(completion_status["world_quests"], WORLD_QUESTS_MAX)
	local hks_completed = colorTextByValue(completion_status["honorable_kills"], HONORABLE_KILLS_MAX)

	local dung_perc = (completion_status["dungeons"] / DUNGEONS_MAX) * 100;
	local wq_perc = (completion_status["world_quests"] / WORLD_QUESTS_MAX) * 100;
	local hk_perc = (completion_status["honorable_kills"] / HONORABLE_KILLS_MAX) * 100;

	print("|cff2962FFHiddenSkinTracker v" .. HST["version"] .. " by Molurax-MoonGuard|r")
	print("You have completed:")
	print("  " .. dungeons_completed .. " of |cff2962FF100|r (" .. dung_perc .."%) dungeons;")
	print("  " .. wqs_completed .. " of |cff2962FF200|r (" .. wq_perc .."%) world quests; and")
	print("  " .. hks_completed .. " of |cff2962FF1000|r (" .. hk_perc .."%) honourable kills.")
end

local frame = CreateFrame("FRAME", "HiddenSkinTrackerFrame");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
frame:RegisterEvent("SUPER_TRACKED_QUEST_CHANGED");
local function eventHandler(self, event, ...)
	HST:updateStats();
end

frame:SetScript("OnEvent", eventHandler);